<template>
    <v-container>
        <v-row align="center" align-content="center" justify="center">
            <v-col cols="8">
                <v-card>
                    <v-card-title>ورود</v-card-title>
                    <v-card-text>
                        <v-form v-model="formIsValid" class="mr-5 ml-5">
                            <v-text-field
                                    label="شماره تلفن یا ایمیل"
                                    v-model="mobile_number"
                                    required
                                    :rules="[v => !!v || 'شماره تلفن یا موبایل الزامی است']"
                            ></v-text-field>
                            <v-text-field v-if="isTokenSended"
                                          v-model="token"
                                          label="کد ورود"
                                          required
                                          :rules="[v => !!v || 'ورود کد الزامی است', v => v.length>=5 || 'کد باید حداقل ۵ رقم باشد']"
                            ></v-text-field>
                        </v-form>
                    </v-card-text>
                    <v-card-subtitle v-show="isTokenSended">زمان باقیمانده: {{timeout}}</v-card-subtitle>
                    <v-card-actions>
                        <v-btn v-if="!isTokenSended" color="primary" :disabled="!formIsValid" @click="generateOtp">
                            ارسال کد
                        </v-btn>
                        <v-btn v-else color="primary" :disabled="(!formIsValid)||timeout<=0" @click="login">
                            ورود
                        </v-btn>
                        <v-btn v-if="timeout===0" color="primary" @click="generateOtp">ارسال دوباره</v-btn>
                    </v-card-actions>
                    <vue-recaptcha
                            sitekey="6LdHFvsUAAAAAEsTW4StGGkiEeNuFBf0jRPp-QQo"
                            :loadRecaptchaScript="true"
                            size="invisible"
                    ></vue-recaptcha>
                </v-card>
            </v-col>
        </v-row>
    </v-container>
</template>

<script>
    import VueRecaptcha from "vue-recaptcha"
    import axios from "axios"
    import {
        setAuthTokens,
    } from "axios-jwt";

    export default {
        name: "Login",
        components: {
            VueRecaptcha
        },
        data() {
            return {
                mobile_number: "",
                token: "",
                formIsValid: true,
                timeout: 120,
                isTokenSended: false
            }
        },
        created() {
            axios.defaults.xsrfCookieName = 'csrftoken';
            axios.defaults.xsrfHeaderName = "X-CSRFTOKEN";
        },
        methods: {
            generateOtp() {
                axios.post(
                    process.env.VUE_APP_BACKEND_URL + "/api/auth/otp/generate/",
                    {mobile_number: this.mobile_number}
                ).then(response => {
                    this.isTokenSended = true;
                    this.timeout = 120;
                    this.countDownTimer();
                    if (response.data.messages === "login") {
                        console.log("login");
                    } else {
                        console.log("signup");
                    }
                }).catch(reason => {
                    alert(reason);
                })
            },
            countDownTimer() {
                if (this.timeout > 0) {
                    setTimeout(() => {
                        this.timeout -= 1;
                        this.countDownTimer()
                    }, 1000)
                }
            },
            login() {
                axios.post(
                    process.env.VUE_APP_BACKEND_URL + "/api/auth/otp/check/",
                    {
                        mobile_number: this.mobile_number,
                        token: this.token
                    }
                ).then(response => {
                    let tokens = response.data.login;
                    let user = response.data.user;
                    console.log(tokens);
                    setAuthTokens({
                        accessToken: response.data.login.access,
                        refreshToken: response.data.login.refresh,
                    });
                    console.log(user);
                    if (user.first_name === "" || user.last_name === "")
                        this.$router.push({name: "Signup", params: {id: user.id}});
                    else
                        this.$router.push({name: "ProfileGeneral", params: {id: user.id}})
                })
            }
        }
    }
</script>

<style scoped>

</style>
